.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include shell32.inc
includelib shell32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

showBalloon proto

makePopupMenu proto

;***************************************************************************************************

;NIF_MESSAGE     equ 01h
;NIF_ICON        equ 02h
;NIF_TIP         equ 04h
NIF_STATE       equ 08h
NIF_INFO        equ 10h

NIIF_NONE       equ 00h
NIIF_INFO       equ 01h
NIIF_WARNING    equ 02h
NIIF_ERROR      equ 03h
NIIF_USER       equ 04h
NIIF_NOSOUND    equ 10h

NOTIFYICONDATA_2 STRUCT
    cbSize              DWORD   ?
    hwnd                DWORD   ?
    uID                 DWORD   ?
    uFlags              DWORD   ?
    uCallbackMessage    DWORD   ?
    hIcon               DWORD   ?
    szTip               BYTE 128 dup(?)
    dwState             DWORD   ?
    dwStateMask         DWORD   ?
    szInfo              BYTE 256 dup(?)
    UNION
        uTimeout        DWORD   ?
        uVersion        DWORD   ?
    ENDS
    szInfoTitle         BYTE 64 dup(?)
    dwInfoFlags         DWORD   ?
NOTIFYICONDATA_2 ENDS

;***************************************************************************************************

IDI_ICON        equ 100

IDM_BALLOON     equ 200
IDM_EXIT        equ 201

WM_STAT         equ WM_USER+120
ID_STAT         equ 299

;***************************************************************************************************

.const
AppName         db "Balloon",0
tippy           db "Balloon",13,10,"Left-click to show balloon;",13,10,"Right-click for menu.",0
balloonMsg      db "I think that I might fly away, in my hot air balloon,",13,10,"And hide from worldly worries on the dark side of the moon;",0

mnu_balloon     db "&Balloon",0
mnu_exit        db "E&xit",0

.data?
hMutex          HANDLE              ?
hInstance       HINSTANCE           ?
hPopup          HMENU               ?
pnt             POINT               <>
iconData        NOTIFYICONDATA_2    <>

.code
start:
    invoke CreateMutex, NULL,TRUE,ADDR AppName
    .IF (eax!=NULL)
        mov hMutex,eax
        invoke GetLastError
        .IF (eax!=ERROR_ALREADY_EXISTS)
            invoke GetModuleHandle, NULL
            mov hInstance,eax
            invoke WinMain
            invoke ReleaseMutex, hMutex
        .ENDIF
        invoke CloseHandle, hMutex
    .ENDIF
    invoke ExitProcess, NULL

;***************************************************************************************************

ALIGN 4
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov [wc].cbSize,SIZEOF wc
    mov [wc].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [wc].hInstance,eax
    invoke LoadIcon, hInstance,IDI_ICON
    mov [wc].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [wc].hCursor,eax
    mov [wc].hbrBackground,COLOR_WINDOW+1
    mov [wc].lpszClassName,OFFSET AppName
    xor eax,eax
    mov [wc].style,eax
    mov [wc].cbClsExtra,eax
    mov [wc].cbWndExtra,eax
    mov [wc].lpszMenuName,eax
    mov [wc].hIconSm,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,NULL,0,0,0,0,HWND_MESSAGE,NULL,hInstance,NULL
    .IF (eax)
        push ebx
        lea ebx,[msg]
        assume ebx:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, ebx,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, ebx
            invoke DispatchMessage, ebx
        .ENDW
        mov eax,[ebx].wParam
        assume ebx:nothing
        pop ebx
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_COMMAND -------------------------------------------------------------------------------------
    .IF (eax==WM_COMMAND)
        ;lParam is hWndCtl
        mov eax,wParam
        mov edx,eax
        and eax,0ffffh      ;item/control/accel ID
        shr edx,16          ;notification code (0=menu; 1=accelerator)
        .IF (eax==IDM_BALLOON)
            invoke showBalloon
        .ELSEIF (eax==IDM_EXIT)
            invoke PostMessage, hwnd,WM_CLOSE,NULL,NULL
        .ENDIF
;-- WM_STAT ----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_STAT)
        .IF (wParam==ID_STAT)
            .IF (lParam==WM_LBUTTONUP)
                invoke showBalloon
            .ELSEIF (lParam==WM_RBUTTONUP)
                invoke GetCursorPos, ADDR pnt
                invoke SetForegroundWindow, hwnd
                invoke TrackPopupMenuEx, hPopup,TPM_LEFTALIGN or TPM_LEFTBUTTON or TPM_RIGHTBUTTON,pnt.x,pnt.y,hwnd,NULL
            .ENDIF
        .ENDIF
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke makePopupMenu
        mov hPopup,eax
        push edi
        mov edi,OFFSET iconData
        assume edi:ptr NOTIFYICONDATA_2
        mov eax,hwnd
        mov [edi].cbSize,SIZEOF NOTIFYICONDATA_2
        mov [edi].hwnd,eax
        mov [edi].uID,ID_STAT
        mov [edi].uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
        mov [edi].uCallbackMessage,WM_STAT
        invoke LoadIcon, hInstance,IDI_ICON
        mov [edi].hIcon,eax
        invoke lstrcpy, ADDR [edi].szTip,ADDR tippy
        invoke Shell_NotifyIcon,NIM_ADD,edi
        assume edi:nothing
        pop edi
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke Shell_NotifyIcon,NIM_DELETE,ADDR iconData
        invoke DestroyMenu, hPopup
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

;***************************************************************************************************

ALIGN 4
showBalloon proc
    push edi
    mov edi,OFFSET iconData
    assume edi:ptr NOTIFYICONDATA_2
    mov [edi].uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP or NIF_INFO
    invoke lstrcpyn, ADDR [edi].szInfo,ADDR balloonMsg,SIZEOF NOTIFYICONDATA_2.szInfo
    invoke lstrcpyn, ADDR [edi].szInfoTitle,ADDR AppName,SIZEOF NOTIFYICONDATA_2.szInfoTitle
    mov [edi].dwInfoFlags,NIIF_USER
    mov [edi].uTimeout,30000
    invoke Shell_NotifyIcon, NIM_MODIFY,edi
    assume edi:nothing
    pop edi
    ret
showBalloon endp

;***************************************************************************************************

ALIGN 4
makePopupMenu proc
    LOCAL minf:MENUITEMINFO
    push ebx
    invoke CreatePopupMenu
    mov ebx,eax
    mov [minf.cbSize],SIZEOF minf
    mov [minf.fMask],MIIM_TYPE or MIIM_STATE or MIIM_ID
    mov [minf.fType],MFT_STRING

    mov [minf.fState],MFS_DEFAULT
    mov [minf.wID],IDM_BALLOON
    mov [minf.dwTypeData],OFFSET mnu_balloon
    invoke InsertMenuItem, ebx,-1,TRUE,ADDR minf

    mov [minf.fState],MFS_ENABLED
    mov [minf.wID],IDM_EXIT
    mov [minf.dwTypeData],OFFSET mnu_exit
    invoke InsertMenuItem, ebx,-1,TRUE,ADDR minf

    mov eax,ebx
    pop ebx
    ret
makePopupMenu endp

;***************************************************************************************************

end start
